#    Copyright 2004 Andrew Wilkinson <aw@cs.york.ac.uk>.
#
#    This file is part of PyLinda (http://www-users.cs.york.ac.uk/~aw/pylinda)
#
#    PyLinda is free software; you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation; either version 2.1 of the License, or
#    (at your option) any later version.
#
#    PyLinda is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public License
#    along with PyLinda; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

class DowncastError(Exception):
    pass
class UnknownFormat(Exception):
    pass
class PackingError(Exception):
    pass

def pack(value):
    try:
        t = value.__class__
    except AttributeError:
        t = type(value)
    try:
        return pack_register[t](value)
    except KeyError:
        raise PackingError, "Unrecognized Type (%s)" % (str(t))

def unpack(data):
    try:
        return unpack_register[data[:data.find("(")]](data)
    except KeyError:
        raise UnknownFormat, "Unrecognized Type %s (%s)" % (data, data[:data.find(")")+1])
    except ValueError:
        raise PackingError, repr(data)

def registerType(type, name, pack, unpack):
    pack_register[type] = pack
    unpack_register[name] = unpack
    type_names[type] = name
    name_types[name] = type

def getTypeName(type):
    return type_names[type]

def getTypeFromName(name):
    return name_types[name]

pack_register = {}
unpack_register = {}
type_names = {}
name_types = {}

import int
del int
import float
del float
import tuple
del tuple
import str
del str
import bool
del bool
import list
del list
import dict
del dict
import type
del type
import none
del none
