#    Copyright 2004 Andrew Wilkinson <aw@cs.york.ac.uk>.
#
#    This file is part of PyLinda (http://www-users.cs.york.ac.uk/~aw/pylinda)
#
#    PyLinda is free software; you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation; either version 2.1 of the License, or
#    (at your option) any later version.
#
#    PyLinda is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public License
#    along with PyLinda; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

def pack(value):
    items = map(lambda x: convert.pack((x, value[x])), value.keys())

    return "python.dict(%s)%s" % (",".join(map(str, map(len, items))), "".join(items))

def unpack(data):
    assert data.startswith("python.dict")

    sizes = map(int, data[data.find("(")+1:data.find(")")].split(","))

    t = {}
    s = data.find(")")+1
    for size in sizes:
        key, value = convert.unpack(data[s:s+size])
        t[key] = value
        s = s + size
    return t

import convert
convert.registerType(dict, "python.dict", pack, unpack)
