#    Copyright 2004 Andrew Wilkinson <aw@cs.york.ac.uk>.
#
#    This file is part of PyLinda (http://www-users.cs.york.ac.uk/~aw/pylinda)
#
#    PyLinda is free software; you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation; either version 2.1 of the License, or
#    (at your option) any later version.
#
#    PyLinda is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public License
#    along with PyLinda; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

def pack(value):
    value = map(convert.pack, value)

    sizes = ",".join(map(str, map(len, value)))
    return "python.list(%s)%s" % (sizes, "".join(value))

def unpack(data):
    assert data.startswith("python.list")

    if data.find(")") == 12:
        return []
    else:
        sizes = map(int, data[12:data.find(")")].split(","))

        l = []
        s = data.find(")")+1
        for size in sizes:
            l.append(convert.unpack(data[s:s+size]))
            s = s + size
        return l

import convert
convert.registerType(list, "python.list", pack, unpack)
